/*
  
Macro Scripts File
Developed:  	30 June 2010
Version:  		3ds MAX 9 SP1
Author:			Giuliano "PapiGiulio" Garau 
Email:			g.garau@gmail.com
www:			    http://www.papigiulio.net

Disclaimer:
Use this script at your own risk.
Any damage caused by this script is not the responsibility of the author.

Usage: This script will automatically use the LAST used export settings, so before using
this script please check your last used export settings.

*/
--***********************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK

macroScript quickxp
category:		"_PapiGiulio" 
buttonText:	"PapiTools"
Tooltip:			"PapiTools - QuickXP - Quick Exporter for .3ds, .obj, .fbx and .dxf files."
icon:#("quickxp",1)
(
	rollout quickxp "Quick Exporter" width:495 height:200
	(
		Groupbox Exporter "Exporter" pos:[10,2] width:475 height:190
		editText folderpath "Directory:" fieldWidth:300 pos:[19,25]
		button browse "Browse" pos:[375,24] width:100 height:19 tooltip:"Browse folder for export"
		editText editfilename "Filename:" fieldWidth:180 pos:[19,60] 
		button default "Default" pos:[260,60] width:100 height:19 tooltip:"Reset filename and/or location to default"
		checkbox chk_loc "Location" pos:[375,60]  checked:false
		checkbox chk_name "Filename"pos:[375,80] checked:false
		
		button exp3ds "Export to 3DS" pos:[50,110] width:110 height:19 height:21
		button expcad "Export to CAD" pos:[187,110] width:110 height:19 height:21
		button expobj "Export to OBJ" pos:[187,150] width:110 height:19 height:21
		button expfbx "Export to FBX" pos:[50,150] width:110 height:19 height:21
		button expall "Export to ALL" pos:[324,110] width:110 height:19 height:21
		progressbar bar3ds "" pos:[51,132] width:110 height:8 value:0 color:[10,255,170]
		progressbar bardxf "" pos:[188,132] width:110 height:8 value:0 color:[10,255,170]
		progressbar barobj "" pos:[188,172] width:110 height:8 value:0 color:[10,255,170]
		progressbar barfbx "" pos:[51,172] width:110 height:8 value:0 color:[10,255,170]
		progressbar barall "" pos:[325,132] width:110 height:8 value:0 color:[10,255,170]
		button killroll "CLOSE" pos:[324,150] width:110  height:30

		
	on expall pressed do
		(
			(
				barall.value = 0
				theClasses = exporterPlugin.classes
				exportFile (folderpath.text+"\\"+(editfilename.text)+".3ds") #noPrompt using:theClasses[1]
				barall.value = 25
			)
			(
			
			--GetINISetting "Fine-bignas3\share\BK_bignas\DS\YAMAHA_living\mat\dwg_export.ini" "Export" 
			theClasses = exporterPlugin.classes
			exportFile (folderpath.text+"\\"+(editfilename.text)+".dxf") #noPrompt using:theClasses[4] 
			barall.value = 50
			)
			(
				
			global BN_CLICKED = 0 -- clicky message ID
			global BM_SETCHECK = 241 -- checkbutton toggle message ID
			global WM_COMMAND = 273 -- windows command message
			global theObjExportTimer -- a .NET timer to check whether obj export is complete or not.

			dialogMonitorOPS.UnRegisterNotification id:#test -- remove any old instance

fn seeIfObjExportIsDoneYet = (
	try (
		-- get all of the popup dialogs
		local popupWindows_hwnds = UIAccessor.GetPopupDialogs()
		-- loop over all of these dialogs
		for child_hwnd in popupWindows_hwnds do (
			-- and find the one titled "Exporting OBJ"
			if (UIAccessor.getWindowText child_hwnd == "Exporting OBJ") then (
				-- now get all of its children UI elements
				local dlgChildren_hwnds = UIAccessor.getChildWindows child_hwnd
				-- loop over those UI elements
				for dlgChild_hwnd in dlgChildren_hwnds do (
					-- see if the "-= DONE =-" button appears to exist
					-- ( the button always exists, but until the export is actually done, will be labeled "Cancel Export" )
					if (UIAccessor.getWindowText dlgChild_hwnd == "-= DONE =-") then (
						-- and press it if it does
						UIAccessor.pressButton dlgChild_hwnd
						-- oh and let's not forget to stop that timer...
						print "Export to OBJ finished"
						theObjExportTimer.stop()
					)
				)
				exit
			)
		)
	)
	catch (
		theObjExportTimer.stop()
	)
)

theObjExportTimer = dotNetObject "System.Windows.Forms.Timer"
dotNet.addEventHandler theObjExportTimer "tick" seeIfObjExportIsDoneYet
theObjExportTimer.interval = 500

fn test = (
	hwnd = DialogMonitorOPS.GetWindowHandle() -- check the dialog that popped up
	hwnd_title = UIAccessor.GetWindowText hwnd
	if (hwnd_title == "OBJ Export Options") then ( -- the obj export config dialog
		local flipControl_hwnd = undefined
		local flipControl_parent_hwnd = undefined
		local controls = windows.getChildrenHWND hwnd -- get all controls for this dialog
		for c in controls do (
			if (c[5] == "Flip YZ-axis (Poser-like)") then (
				flipControl_hwnd = c[1]
				flipControl_parent_hwnd = c[2]
				exit
			)
		)
		local flipControl_id = UIAccessor.GetWindowResourceID flipControl_hwnd
		windows.sendMessage flipControl_hwnd BM_SETCHECK 1 0 -- uncheck the Flip YZ-axis option.  Set to '1 0' to check it.
		windows.sendMessage flipControl_parent_hwnd WM_COMMAND ((bit.shift BN_CLICKED 16) + flipControl_id) flipControl_hwnd

		-- REMOVE THIS WHEN CONFIDENT THINGS WORK
-- 		sleep 3 -- let's sleep here for a bit so you can check if that checkbox got checked
		-- /REMOVE THIS WHEN CONFIDENT THINGS WORK

		UIAccessor.PressButtonByName hwnd "Export" -- press the Export button
	) -- hwnd_title == "OBJ Export Options"
	else if (hwnd_title == "Exporting OBJ") then (
		-- oh nasty.  This dialog pops up, and it's a 'progress' dialog.  So we'll have to check it at an interval.. lovely!
		-- invoke the .NET timer
		theObjExportTimer.start()
	) -- hwnd_title == "Exporting OBJ"
	else if (hwnd_title == "Error") then (
		-- we could check what the actual error is, but let's save that for if/when that's needed.
		print "An error occurred while attempting to export to .OBJ -- perhaps nothing to export?"
		UIAccessor.pressButtonByName hwnd "OK"
	)
	true
)
dialogMonitorOPS.RegisterNotification test id:#test -- register the monitor
dialogMonitorOps.enabled = true -- enable the monitor
exportFile (folderpath.text+"\\"+(editfilename.text)+".obj") 
-- using:theClasses[17] 
-- exportFile "c:\\temp\\somefile.obj" -- pop up the obj export config dialog (see above function for what happens next)
dialogMonitorOPS.UnRegisterNotification id:#test -- remove the monitor
dialogMonitorOps.enabled = false -- disable the monitor
	barall.value = 75
			)
			(
			exportFile (maxfilepath+"\\"+(getFilenameFile maxfilename)+".fbx") #noprompt using:FBXEXP
			barall.value = 100
			)
		)
			
			
			
			
			
		on killroll pressed do
		(
			destroydialog quickxp
		)
		
		on editfilename entered txt do
		(
			if txt == ""do
			(
				editfilename.text = "Enter correct filename"
			)
		)
		 
		fn overwrt filename = 
			( 
			if getFilenamePath filename == "" do 
			filename = getdir #scene + "\\" + filename 
			if (not (doesfileexist filename)) or 
			querybox ("filename: "+filename + "\nexists. Overwrite?") then 
			( 
			saveMaxFile filename 
			true 
			) 
			else 
			false 
			)

		
		on quickxp open do
			(
			folderpath.text = (maxfilepath)
			editfilename.text = Getfilenamefile(maxFilename)
			)

		on default pressed do
			(
				if chk_loc.checked do folderpath.text = (maxfilepath)
				if chk_name.checked do editfilename.text = Getfilenamefile(maxFilename)
			)
				
		on exp3ds pressed do	
			(
			bar3ds.value = 0
			theClasses = exporterPlugin.classes
			exportFile (folderpath.text+"\\"+(editfilename.text)+".3ds") #noPrompt using:theClasses[1]
			bar3ds.value = 100
			)
		
			
		on expfbx pressed do
			(
			barfbx.value = 0
			exportFile (maxfilepath+"\\"+(getFilenameFile maxfilename)+".fbx") #noprompt using:FBXEXP
			barfbx.value = 100
			)
			
			
		on browse pressed do
			(
			path = getSavePath caption:"Export directory"
			if (path != undefined) then
					(
					folderpath.text = path
					)
					else
					(
					folderpath.text = "Select a directory"
					)
			)
			
			
		on expcad pressed do	
			(
			bardxf.value = 0
			theClasses = exporterPlugin.classes
			exportFile (folderpath.text+"\\"+(editfilename.text)+".dxf") #noPrompt using:theClasses[4] 
			bardxf.value = 100
			)

			
			on expobj pressed do
			(
				barobj.value = 0
			global BN_CLICKED = 0 -- clicky message ID
			global BM_SETCHECK = 241 -- checkbutton toggle message ID
			global WM_COMMAND = 273 -- windows command message
			global theObjExportTimer -- a .NET timer to check whether obj export is complete or not.

			dialogMonitorOPS.UnRegisterNotification id:#test -- remove any old instance

fn seeIfObjExportIsDoneYet = (
	try (
		-- get all of the popup dialogs
		local popupWindows_hwnds = UIAccessor.GetPopupDialogs()
		-- loop over all of these dialogs
		for child_hwnd in popupWindows_hwnds do (
			-- and find the one titled "Exporting OBJ"
			if (UIAccessor.getWindowText child_hwnd == "Exporting OBJ") then (
				-- now get all of its children UI elements
				local dlgChildren_hwnds = UIAccessor.getChildWindows child_hwnd
				-- loop over those UI elements
				for dlgChild_hwnd in dlgChildren_hwnds do (
					-- see if the "-= DONE =-" button appears to exist
					-- ( the button always exists, but until the export is actually done, will be labeled "Cancel Export" )
					if (UIAccessor.getWindowText dlgChild_hwnd == "-= DONE =-") then (
						-- and press it if it does
						UIAccessor.pressButton dlgChild_hwnd
						-- oh and let's not forget to stop that timer...
						print "Export to OBJ finished"
						theObjExportTimer.stop()
					)
				)
				exit
			)
		)
	)
	catch (
		theObjExportTimer.stop()
	)
)

theObjExportTimer = dotNetObject "System.Windows.Forms.Timer"
dotNet.addEventHandler theObjExportTimer "tick" seeIfObjExportIsDoneYet
theObjExportTimer.interval = 500

fn test = (
	hwnd = DialogMonitorOPS.GetWindowHandle() -- check the dialog that popped up
	hwnd_title = UIAccessor.GetWindowText hwnd
	if (hwnd_title == "OBJ Export Options") then ( -- the obj export config dialog
		local flipControl_hwnd = undefined
		local flipControl_parent_hwnd = undefined
		local controls = windows.getChildrenHWND hwnd -- get all controls for this dialog
		for c in controls do (
			if (c[5] == "Flip YZ-axis (Poser-like)") then (
				flipControl_hwnd = c[1]
				flipControl_parent_hwnd = c[2]
				exit
			)
		)
		local flipControl_id = UIAccessor.GetWindowResourceID flipControl_hwnd
		windows.sendMessage flipControl_hwnd BM_SETCHECK 1 0 -- uncheck the Flip YZ-axis option.  Set to '1 0' to check it.
		windows.sendMessage flipControl_parent_hwnd WM_COMMAND ((bit.shift BN_CLICKED 16) + flipControl_id) flipControl_hwnd

		-- REMOVE THIS WHEN CONFIDENT THINGS WORK
-- 		sleep 3 -- let's sleep here for a bit so you can check if that checkbox got checked
		-- /REMOVE THIS WHEN CONFIDENT THINGS WORK

		UIAccessor.PressButtonByName hwnd "Export" -- press the Export button
	) -- hwnd_title == "OBJ Export Options"
	else if (hwnd_title == "Exporting OBJ") then (
		-- oh nasty.  This dialog pops up, and it's a 'progress' dialog.  So we'll have to check it at an interval.. lovely!
		-- invoke the .NET timer
		theObjExportTimer.start()
	) -- hwnd_title == "Exporting OBJ"
	else if (hwnd_title == "Error") then (
		-- we could check what the actual error is, but let's save that for if/when that's needed.
		print "An error occurred while attempting to export to .OBJ -- perhaps nothing to export?"
		UIAccessor.pressButtonByName hwnd "OK"
	)
	true
)
dialogMonitorOPS.RegisterNotification test id:#test -- register the monitor
dialogMonitorOps.enabled = true -- enable the monitor
exportFile (folderpath.text+"\\"+(editfilename.text)+".obj") 
-- using:theClasses[17] 
-- exportFile "c:\\temp\\somefile.obj" -- pop up the obj export config dialog (see above function for what happens next)
dialogMonitorOPS.UnRegisterNotification id:#test -- remove the monitor
dialogMonitorOps.enabled = false -- disable the monitor
	barobj.value = 100
			)
	/*		
		on expobj pressed do	
			(
			barobj.value = 0
			local iniPath_exportSettings = objExp.getIniName()
			setINISetting iniPath_exportSettings "Geometry" "FlipZyAxis" "1"
			setINISetting iniPath_exportSettings "Geometry" "Shapes" "1"
			setINISetting iniPath_exportSettings "Geometry" "ExportHiddenObjects" "0"
			setINISetting iniPath_exportSettings "Geometry" "FaceType" "2"--quads
			setINISetting iniPath_exportSettings "Geometry" "TextureCoords" "1"
			setINISetting iniPath_exportSettings "Geometry" "Normals" "1"
			setINISetting iniPath_exportSettings "Geometry" "SmoothingGroups" "1"
			setINISetting iniPath_exportSettings "Geometry" "ObjScale" "1.000000"
			
			setINISetting iniPath_exportSettings "Output" "RelativeIndex" "0"
			setINISetting iniPath_exportSettings "Output" "Target" "0"
			setINISetting iniPath_exportSettings "Output" "Precision" "4"
			
			--new discovered settings by copypastepixel that are important for roadkill,see:
			--http://boards.polycount.net/showpost.php?p=1115492&postcount=16
			setINISetting iniPath_exportSettings "Optimize" "optVertex" "1"
			setINISetting iniPath_exportSettings "Optimize" "optNormals" "1"
			setINISetting iniPath_exportSettings "Optimize" "optTextureCoords" "1"
			theClasses = exporterPlugin.classes
			sceneObjs = #()
			exportFile (folderpath.text+"\\"+(editfilename.text)+".obj") #noPrompt using:theClasses[17] 
			barobj.value = 100
			)
			*/
			
		
	)
	createdialog quickxp
	)
